<?php

namespace FiloBlu\Maintenance\Helper;

class Data extends \Magento\Framework\App\Helper\AbstractHelper {

    const COOKIE_NAME = 'filoblu_maintenance_admin_loggedin';

    /**
     * @var \Magento\Framework\HTTP\PhpEnvironment\RemoteAddress
     */
    protected $remoteAddress;
    protected $cookieManager;

    public function __construct(
        \Magento\Customer\Model\Session $customerSession,
        \Magento\Framework\App\Helper\Context $context,
        \Magento\Framework\Stdlib\CookieManagerInterface $cookieManager
    ) {

        $this->remoteAddress = $context->getRemoteAddress();
        $this->customerSession = $customerSession;
        $this->cookieManager = $cookieManager;
        parent::__construct($context);
    }

    public function getConfig($config_path, $section = 'filoblu_maintenance_section') {
        return $this->scopeConfig->getValue(
                        $section . '/' . $config_path, \Magento\Store\Model\ScopeInterface::SCOPE_STORE
        );
    }

    public function isAllowedIp() {
        $isAllowed = false;
 
        if ($this->getConfig("general/allowed_ips") && in_array($this->remoteAddress->getRemoteAddress(), explode(",",trim($this->getConfig("general/allowed_ips"))))) {
            $isAllowed = true;
        }

        return $isAllowed;
    }

    public function isAdminOnlyAllowed() {
        return $this->scopeConfig->isSetFlag('filoblu_maintenance_section/general/admin_only');
    }

    public function isValidAdmin() {
        return $this->cookieManager->getCookie(self::COOKIE_NAME, 0) == 1;
    }

}
